C md of read_iris_sweeps to find rats  with interference/multuple trip echo
C once i find the rats, then plot variables and test spw/sqi theshoilding
c /read in a radar tape file and write out sweeos in the
c SIGMET/Vaisala IRIS Raw data format. to simlate sweeps
C written out by the RVP8. Oh how I did not want to
C write this code.... started 9 Dec 2008. Peter Dodge,
C radar data p;umber, HRD 
C Iris data structures
	parameter(max_rays = 500, max_gates = 1024)

	integer rot_dir, ray_table(max_rays)
	real ray_time(max_rays)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn, temp_fn
COUT	integer*4 swp_lu
	integer*8 swp_lu

	integer*4 iostat
	integer*4 nrem, tot_read
C includes
	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type (struct_hdr) str_hdr
	type (product_config ) prod_conf
	type (product_end ) prod_end
	type (ingest_configuration ) i_config
	type (task_sched_info ) t_sched
	type (task_dsp_info ) t_dsp
	type (task_calib_info ) t_calib
	type (task_range_info ) t_range
	type (task_scan_info )t_scan

	type (ymds_time ) start_time_str
	type (ymds_time ) end_time_str
	
	type (task_misc_info ) t_misc
	type (task_end_info ) t_end

	type (task_rhi_scan_info) t_rhi
	type (task_ppi_scan_info) t_ppi
	
	type (ingest_data_hdr) idh(MAX_FIELDS) ! /* should be more general! */
	type (raw_prod_bhdr)  rpbh
	type (ray_hdr) rh(max_rays)
	type (TDR_hdr)  air_hdr(max_rays)

C and here are the arrays for the pther data types:
	real dbz(max_gates), dop(max_gates), wid(max_gates)
C and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*80 radar_fn
	character*4 time_string

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"
	logical tail_fore, tail_aft
	logical french_antenna
	character*1 antenna_type
C
	integer list_lu
	character*80 sweep_list
C
C array of flags to select data
	integer data_sel_flags(3)
C
C defauly data to retrieve
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2

	bad_val = -999.0
	list_lu = 22
C
	
	read_stuff = 0 ! set to  1 to get massive dump of info
	call getarg(1, sweep_list)
	if(sweep_list .eq. ' ')then
	  write(6,*)'enter sweeps list '
	  read(5,'(a)') sweep_list
	end if
C
	open(list_lu, file = sweep_list, form='formatted',
     +   status ='old')
	ifile_num = 0
C write headings that eill appear first 
C when grepping out of the massive dump i create
	write(6,1121)
cout	write(6,*)'Nav, time rlat, rlon, ra, ',
cout     +		' wspd, wdir'

	write(6,*)'az stat, time, daz_avg, ',
     +		' daz_min, daz_max,rot_dir'
	write(6,*)'PRF Mode, swp_dop_min,swp_dop_max,vel_nyq '

10	read(list_lu,'(a)',end = 900, err = 900)sweep_fn

c
	call open_iris_file(swp_lu, sweep_fn, iostat)
	write(6,*)iostat,' iostat opening ', sweep_fn
cdout	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
cdout		write(6,*) "Opened sweep file", sweep_fn
	end if
C
	ifile_num = ifile_num + 1
C ony dump product and taxk headers for first
C file in the list
	if(ifile_num .eq. 1) then
	  lu_out = 6
	else
	  lu_out = 0
	end if

	call check_byte_swapping(swp_lu, swapped)
c
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
cdout	write(6,*)' read first record'
	call read_product_hdr(lu_out, prod_conf, prod_end)

	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_sched, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
cdout	write(6,*)' Read record 2'
C
	tot_read = 2 * BLK_LENGTH 

	call read_task_hdr(lu_out, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
	wavelength= t_misc%wavelength * 0.0001
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )

Cout	vel_nyq = t_misc%wavelength * 0.0001 * t_dsp%prf * 0.25
	write(6, *)"Myquist velocity ",vel_nyq," m/s PRF Mde: ",
     +		t_dsp%prf_mode


C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
cout	num_sweeps =1 !  t_scan.num_sweeps
	num_sweeps = t_scan%num_sweeps
C files may have multiple sweeps.
	num_fields = i_config%num_assoc_files / num_sweeps
	write(6,*)'mun fields, sweeps ',num_fields, num_sweeps
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	   num_good_rays = 0
	   avg_ra = 0.0
	   avg_rlat = 0.0
	   avg_rlon = 0.0
	   avg_wdir = 0.0
	   avg_wspd = 0.0
C
	   avg_roll = 0.0
cdout	   write(6,*)" *** Sweep # ",isweep," of file ",sweep_fn
C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	  num_rays = idh(num_fields)%expected_num_rays
C finally read the rays and expand the data, including the extended headers

	  prev_lat = -999.9
	  prev_lon = -999.9
	  prev_az = -999.9
C sweep start holds ingest data time from
C product header, stored as time in common vloxk until
C rays are read. Not sur if this is the best tume to
C call sweep start but that is what i will use for now.
	  sweep_start = time
C i set those nust in case the first rays are zero length ones that
C will not have good nav data. It will
C be obvious if that causedd a nav jump,  nc 
C bad nav in otherwise good ray.
	  swp_dop_max = -999.9
	  swp_dop_min = -swp_dop_max

	  swp_dop_max = -999.9
	  swp_dBZ_min = -swp_dBZ_max

	  swp_wid_max = -999.9
	  swp_wid_min = -swp_wid_max

	  num_good_rays = 0
	  do i = 1, num_rays
c set time gad intil oterwise
		ray_time(i) = -1.0
cdout	   write( 6, '("ray # ", i3, 58("=") )'), i
	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)	   
	   if(io_error .ne. 1) then
		write(6,*)'ray i/o error ',io_error
		go to 333
cout	   else
cout		num_good_rays = num_good_rays + 1
	   end if
c
	   num_bins = rh(i)%num_bins_in_ray
C only check rays with data, num_bins != 0
	   if( num_bins .gt. 0) then ! >>>>>>>>>>>>>
	   call read_TDR_hdr(0, air_hdr(i) )
C update time
	      ray_time(i) = sweep_start + 
     +		air_hdr(i)%time_since_sweep_start * 0.001

	   if(i .gt. 1) then
		dlat=abs(rlat-prev_lat)
		dlon = abs(rlon-prev_lon)
		if(dlat .gt. 0.01 .or. dlon.gt.0.01)then
		  write(6,124)ifile_num, i, num_bins,
     +			prev_lat,rlat,prev_lon,rlon
124		  format('jump ',i4,1x,i3,1x,i4,1x,2(f6.3,1x),2(1x,f8.3))
		end if
C only update prev pos if nbins .gy 0
		prev_lat = rlat
		prev_lon = rlon
C
	   end if

	   avg_roll = avg_roll + roll
	   avg_ra = avg_ra + ra
	   avg_rlat = avg_rlat + rlat
	    avg_rlon = avg_rlon + rlon
	   avg_wdir = avg_wdir + wd
	   avg_wspd = avg_wspd + ws
c load sweep arrays for later display
	   do ib = 1, num_bins
		dbz_sweep( ib, i) = dbz(ib)
		dop_sweep(ib, i) = dop(ib)
		spw_sweep( ib, i) = wid( ib )
	   end do
C note taht i swap az and el, so first angle is the rotation, 2nd is the tilt
	   az_el(1, i) = bam16_TO_de g(rh(i)%el_beg )
	   az_el(2, i) =bam16_TO_de g( rh(i)%az_beg )

	   call get_ray_min_max(dbz, num_bins, bad_val,dbz_min, dbz_max)
	   call get_ray_min_max(dop, num_bins, bad_val,dop_min, dop_max)
	   if((abs(dop_min) .gt. vel_nyq) .or.
     +		(abs(dop_max) .gt. vel_nyq) ) then

		call dop_ray_check(dop, vel_nyq, num_bins, 
     +		  dop_min, dop_max, i_min, i_max, num_under, 
     +		  num_over,num_good,num_bad)

		write(6,*)"dop check ",i_min,dop_min,i_max,dop_max,
     +		   num_under, num_over, num_good,num_bad
	   end if
	   if(dop_min .lt. swp_dop_min)swp_dop_min = dop_min
	   if(dop_max .gt. swp_dop_max)swp_dop_max = dop_max
	   call get_ray_min_max(wid, num_bins, bad_val,wid_min, wid_max)
cdput	   write(6, 111)i, az_el(1,i), az_el(2,i), dbz_min, dbz_max,
cdout     +		dop_min, dop_max, wid_min, wid_max
111	   format('Ray # ',i3, 1x, f7.2, 1x, f6.2, 1x,6(f6.2,1x) )

	    num_good_rays = num_good_rays + 1
	  end if ! <<<< good ray if block <<<<<<<<<<<<<<<<<<<<<<<<<<<<
	  end do ! rays loop
333	num_rays = num_good_rays
	  avg_roll = avg_roll / num_good_rays
	  avg_ra = avg_ra/num_good_rays
	  avg_rlat = avg_rlat / num_good_rays
	  avg_rlon = avg_rlon / num_good_rays
	  avg_wdir = avg_wdir / num_good_rays
	  avg_wspd = avg_wspd / num_good_rays
	  write(6,112)ih,im,is, is100,
     +		avg_rlat, avg_rlon, avg_ra,
     +		avg_wspd, avg_wdir
112	format("nav ", 3i2.2,".",i2.2,
     +	1x, f6.3,1x,f8.3, 1x, f7.1,
     +	f6.1, 1x, f6.1)
1121	format("nav ", "Time UTC",
     +	1x, "  :at ",1x," Long ", 1x, 
     +	"alt (m)",1x, " W spd", 1x, "W dir")
cdput	  write(6,*)avg_rlat, avg_rlon,' avg lat, lon in ',sweep_fn
cdout	  write(6,*)avg_wspd, avg_wdir,' avg wind wd, ws in ',sweep_fn
cdout	  write(6,*)avg_roll,' deg avg roll in ',sweep_fn
C there may be stuff remaining atend of last record in the
C sweep.
	  call skip_iris_words(swp_lu, nrem )
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


	call close_iris_file(swp_lu)
C now look for azimuth jumps...
	call make_ray_table(num_rays, ray_time,ray_table, rot_dir)
C
	call check_abs_tdr_angles(num_rays,ray_table,
     +	   az_el, rot_dir, daz_avg, daz_min, daz_max)
	write(6,222)ih,im,is,daz_avg,
     +		daz_min, daz_max,rot_dir
222	format("az stat ",3i2.2,1x,3(1x,f7.2),1x,i2)
	write(6,223)t_dsp%prf_mode,swp_dop_min,swp_dop_max,vel_nyq
223	format("PRF mode ",i1," Dop min,max ",2(1x,f7.2),1x,f6.2)
	if(swp_dop_min.lt. -vel_nyq ) then
	 write(6,224)swp_dop_min,vel_nyq
224	  format("Zut Dop min, Nyq vel ",1x,f7.2,1x,f6.2)
	else if(swp_dop_max.gt.vel_nyq ) then
	 write(6,225 )swp_dop_max,vel_nyq
225	 format("Zut Dop max, Nyq vel ",1x,f7.2,1x,f6.2)
	end if
	go to 10  ! file loop
900	write(6,*)'finished sweeps'
	end
C =====================================
	subroutine dop_ray_check(dop, vel_nyq, num_bins, 
     +		dop_min, dop_max, i_min, i_max, num_under, 
     +		num_over,num_good, num_bad)
	integer num_bins, i_min, i_max
	real dop(num_bins), dop_min,  dop_max
	real vel_nyq, bnd_nyq
	integer num_good, num_bad
	integer num_under, num_over
C
	i_min = -1
	i_max = -1
	num_under = 0
	num_over = 0
	num_bad = 0
	num_good = 0
	dop_min = 400.0
	dop_max = -400.0
	bnd_nyq = vel_nyq + 0.5
C
	do i = 1, num_bins
	  if(dop(i) .gt. -327.6) then
		if(dop(i).gt.dop_max)then
		   dop_max = dop(i)
		   i_max = i
		end if
		if(dop(i).lt.dop_min)then
		   dop_min = dop(i)
		   i_min = i
		end if
		if(dop(i) .lt. -bnd_nyq) then
			num_under = num_under + 1
		else if( dop(i) .gt. bnd_nyq) then
			num_over = num_over + 1
		else
			num_good = num_good + 1
		end if
	  else
		num_bad = num_bad + 1
	  end if
	end do
	return
	end
	subroutine make_ray_table(num_rays, ray_time,ray_table, rot_dir)
C
	integer num_rays
	real ray_time(num_rays)
	integer ray_table(num_rays)
	integer rot_dir
C
c find start ray number
	time_start = 1440000.0
	time_end = -time_start
	do i = 1, num_rays
	     if( ray_time(i) .ge. 0.0) then
		if(ray_time(i).lt.time_start) then
			time_start = ray_time(i)
			ifirst_ray = i
		end if
		if(ray_time(i).gt.time_end) then
			time_end = ray_time(i)
			last_ray = i
		end if
	     end if
	end do
	write(6,*)'First and last ray ',ifirst_ray, last_ray
C now use first and last ray to figure out totation and load
	if( ifirst_ray .gt. last_ray)then
C widdershins (counter-clockwise)
	  rot_dir = -1
	  iray = 1
	  do i = ifirst_ray, num_rays
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = 1, last_ray
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray+1, ifirst_ray-1, 1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C 
	else if( ifirst_ray .lt. last_ray)then
C clockwise
	  rot_dir = 1
	  iray = 1
	  do i = ifirst_ray, 1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = num_rays, last_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray-1, ifirst_ray+1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C
	end if
C Now flad rays with time of -1.0
	do i = 1, num_rays
	  if( ray_time(ray_table(i)) .lt. 0.0) then
		ray_table(i) = -1
	   end if
	end do

C debug, dump ray_table
cd	write(6,*)'debug. ray table'
cd	do i = 1, num_rays
cd	 if(ray_table(i) .gt. 0) then
cd	  write(6,*)'Ray Table ',i,ray_table(i),ray_time(ray_table(i))
cd	 else
cd	  write(6,*)'Ray Table ',i,ray_table(i), -1.0
cd	 endif
cd	end do
cd	write(6,*)' found rot_dir ', rot_dir
	return
	end
C ====================================
	subroutine check_tdr_angles(num_rays,ray_table,
     +	   az_el, rot_dir, daz_avg, daz_min, daz_max)
c
	integer num_rays, ray_table(num_rays)
	integer rot_dir ! 1 = clockwise, -1 counterclockwise
	real az_el(2,num_rays)
	real daz_avg, daz_min, daz_max
C
	write(6,*)'input n rays, rot dir ',num_rays, rot_dir
c now use the ray_table to look at antenna
C rotation angles
	prev_az = az_el(1, ray_table(1))
	daz_min = 360.0
	daz_max = -daz_min
	daz_avg = 0.0
	num_good_rays = 1

	do i = 2, num_rays
	  if(ray_table(i) .ne. -1) then
	    num_good_rays = num_good_rays + 1
	    del_az = az_el(1,ray_table(i)) - prev_az
C fix over large del az at 0/360 crossing
	    if(rot_dir .eq. -1) then
c nav angles decrease in ccw rotation, do del az
c should be a negative number.
	      if(del_az .gt. 180.0) then
		del_az = del_az - 360.0
	      end if
	    else ! clockwise
	      if(del_az .lt. -180.0) then
		del_az = 360.0 + del_az
	      endif
	    end if
	    prev_az = az_el(1,ray_table(i))
	    if(del_az .gt. daz_max) then
		daz_max = del_az
	    end if
	    if(del_az .lt. daz_min) then
		daz_min = del_az
	    end if
	    daz_avg = daz_avg + del_az
	  end if
	end do
	daz_avg = daz_avg / (num_good_rays - 1)
	
C
	return
	end
C ====================================
	subroutine check_abs_tdr_angles(num_rays,ray_table,
     +	   az_el, rot_dir, daz_avg, daz_min, daz_max)
c
	integer num_rays, ray_table(num_rays)
	integer rot_dir ! 1 = clockwise, -1 counterclockwise
	real az_el(2,num_rays)
	real daz_avg, daz_min, daz_max
C
c now use the ray_table to look at antenna
C rotation angles
	prev_az = az_el(1, ray_table(1))
	daz_min = 360.0
	daz_max = -daz_min
	daz_avg = 0.0
	num_good_rays = 1

	do i = 2, num_rays
	  if(ray_table(i) .ne. -1) then
	    num_good_rays = num_good_rays + 1
	    del_az = abs(az_el(1,ray_table(i)) - prev_az)
C fix over large del az at 0/360 crossing
	    if(del_az .gt. 180.0) then
		del_az = 360.0 - del_az
	    end if
	    prev_az = az_el(1,ray_table(i))
	    if(del_az .gt. daz_max) then
		daz_max = del_az
	    end if
	    if(del_az .lt. daz_min) then
		daz_min = del_az
	    end if
	    daz_avg = daz_avg + del_az
	  end if
	end do
	daz_avg = daz_avg / (num_good_rays - 1)
	
C
	return
	end




