	Program radials_split_sweep
	implicit none
        include "hrd_radar_settings.f"
        character*4 sweeptype
        real timeraddiff,timerad1,timeraddiffer,timerad2
        real timetest
 	integer ielevtest,iazicount,ia,iai,k,newsweep
	integer lu, iyear, imonth, iday, ihour,il
	integer iminute, isecond, maxi
        real azitest,azi1,sumazm,trackeazm,dellat,dellon
	real  radius(max_hrd_dim), vr(10000,max_hrd_dim)
	character*10 vrc(max_hrd_dim), vrcc, timeradc, rrlatc
	character*10 rrlonc, rrac, eazmc, eevc
	real timerad(10000)
        integer ilongitude,nread
        real latitude(4),longitude(4),eevia
        double precision rrlat(10000), rrlon(10000) 
  	real rra(10000), eazm(10000), eev(10000)
	integer iost, icalled, mu, i, length_file, iwrite, ivalid
	real lat0, lon0, elv0, elv1, diffazm
	character*180 filename, outfile
	integer external iargc

C----------------------------------------------------------------
C Get argc
	if (iargc() .lt. 1) then
	 write(6,*) ' usage: radials_delete 050825I1_1401_1441_radials'
	 stop
	else
	 call getarg(1, filename)
	 length_file = len_trim(filename)
	endif
	lu=11
	mu=21
        ilongitude=0
        nread=0
	open(lu, file='../Raw/'//filename(1:length_file)//'.txt', 
     1        form='formatted')
	read(lu,'(3i2,x,i4)')iyear, imonth, iday, maxi
        write(6,*)iyear,imonth,iday,maxi
	read(lu,'(8f10.3)')(radius(i),i=1,maxi)
        write(6,'(8f10.3)')(radius(i),i=1,maxi)
	elv0=60.
	elv1=85.
	iwrite=0
        ia=0
        timerad1=0
        timerad2=0
	do_get_vr_loop : do
C... get data
C     read(lu,'(8f10.3)', iostat = iost )timerad, rrlat, rrlon, rra, 
C    1 eazm, eev
C              (vr(i), i=1,maxi)
	   read(lu,'(8a10)', iostat = iost )timeradc, 
     1                       rrlatc, rrlonc, 
     1                       rrac, eazmc, eevc,
     1                       (vrc(i), i=1,maxi)
           read(timeradc,'(f10.3)')timetest
           if(timetest.lt.-2.)then
            read(lu,'(a4)')sweeptype
 	    read(lu,'(8a10)', iostat = iost )timeradc, 
     1                       rrlatc, rrlonc, 
     1                       rrac, eazmc, eevc,
     1                       (vrc(i), i=1,maxi)
            ielevtest=1
           else
            ielevtest=0
           endif
	   if( iost < 0 ) exit
           ia=ia+1
	   read(timeradc,'(f10.3)')timerad(ia)
           write(6,'(6a10)')timeradc,rrlatc,rrlonc,rrac,eazmc,eevc
           write(6,'(i4,f10.3)')ia,timerad(ia)
	   read(rrlatc  ,'(f10.3)')rrlat(ia)
	   read(rrlonc  ,'(f10.3)')rrlon(ia)
	   read(rrac    ,'(f10.3)')rra(ia)
	   read(eazmc   ,'(f10.3)')eazm(ia)
	   read(eevc    ,'(f10.3)')eev(ia)
	   ivalid=1
	   do i = 1, maxi
	      vrcc=vrc(i) 
	      if (vrcc .eq. '       NaN') then
	          vr(ia,i)=   -888.800
	      elseif (vrcc .eq. '  -888.800') then
	          vr(ia,i)=   -888.800
	      else
	          ivalid = ivalid + 1
	          read(vrcc, '(f10.3)')vr(ia,i)
	      endif
	   enddo
           eevia=eev(ia)
c           if(timeraddiffer.lt.2..and.ia.gt.1.and.
c     1        abs(elv1-eev(ia)).gt.70)then
c            ielevtest=1
c           else
c            ielevtest=0
c           endif
c           write(6,*)elv1,eev(ia)
c           if(timeraddiff.ge.8..or.
c     1	    (ielevtest.eq.1.and.azitest.lt.0))then
           if(ielevtest.eq.1)then
c           write(6,*)'ia,timerad1,timerad,timeraddiff = ',
c     1      ia,timerad1,timerad(ia),timeraddiff
c           write(6,*)'elv1,eev(ia),azi1,eazm,azitest = ',
c     1      elv1,eev(ia),azi1,eazm(ia),azitest
	       iwrite = iwrite + 1
	       ihour = int(timerad(1)/3600.)
               if(nread.eq.0)then
                nread=1
c                if(ihour.ge.24)iday=iday-1
                if(iday.eq.0)then
                 imonth=imonth-1
                 if(imonth.eq.4)iday=30
                 if(imonth.eq.5)iday=31
                 if(imonth.eq.6)iday=30
                 if(imonth.eq.7)iday=31
                 if(imonth.eq.8)iday=31
                 if(imonth.eq.9)iday=30
                 if(imonth.eq.10)iday=31
                 if(imonth.eq.11)iday=30
                endif
               endif
	       iminute = int((timerad(1) - ihour*3600)/60)
	       isecond = int( timerad(1) - ihour*3600 - iminute*60 )
               if(ia.ge.20)then
                if(ilongitude.eq.0)then
                 longitude(1)=rrlon(1)
                 longitude(2)=rrlon(1)
                 longitude(3)=rrlon(ia)
		 longitude(4)=rrlon(ia)
		 latitude(1)=rrlat(1)
		 latitude(2)=rrlat(1)
		 latitude(3)=rrlat(ia)
		 latitude(4)=rrlat(ia)
                 ilongitude=1
		else
                 do il=1,3
		  latitude(il)=latitude(il+1)
		  longitude(il)=longitude(il+1)
		 enddo
		 latitude(4)=rrlat(ia)
		 longitude(4)=rrlon(ia)
		endif
                dellat=latitude(4)-latitude(1)
                dellon=longitude(4)-longitude(1)
                dellat=dellat*111.1
                dellon=dellon*111.1*cos(rrlat(1)*3.14159/180.)
c		write(6,*)'lat1,lat2 = ',latitude(1),latitude(4)
c 		write(6,*)'lon1,lon2 = ',longitude(1),longitude(4)
c                write(6,*)'rlat,rlon = ',rrlat(ia),rrlon(ia)
c                write(6,*)dellat,dellon
		trackeazm=180./3.14159*atan2(dellat,dellon)
                sumazm=0.
c                write(6,*)trackeazm
                do iai=1,ia
		 diffazm=eazm(iai)-trackeazm
 		 sumazm=sumazm+cos(diffazm*3.14159/180.)
c                 write(6,*)'iai,eazm,trackeazm,sumazm = ',
c     1            iai,eazm(iai),trackeazm,sumazm
                enddo
c                write(6,*)'trackeazm,sumazm = ',trackeazm,sumazm
                write(6,*)sweeptype
                if(sweeptype.eq.'FORE')then
                 iwrite=1
		else
		 iwrite=0
		endif
                write(6,*)'iwrite = ',iwrite
                write(outfile,'(6i2.2,a1,i1)')
     1          iyear, imonth, iday, ihour, iminute,
     1          isecond, '_', iwrite
 	        write(6,'(6i2.2,a1,i1)')
     1          iyear, imonth, iday, ihour, iminute, 
     1          isecond, '_', iwrite
 	        open(mu, file='../'//outfile(1:6)/
     1                 /'/'//outfile(1:14)//'.swp')
	        write(mu,'(3i2,x,i4)')iyear, imonth, iday, maxi
	        write(mu,'(8f10.3)')(radius(i),i=1,maxi)
                do iai=1,ia-1
   	         if(ivalid > 0) write(mu,'(8f10.3)')
     1           timerad(iai), rrlat(iai), rrlon(iai), rra(iai), 
     `            eazm(iai), eev(iai),(vr(iai,i), i=1,maxi)
                enddo
               endif
               timerad(1)=timerad(ia)
               rrlat(1)=rrlat(ia)
	       rrlon(1)=rrlon(ia)
	       rra(1)=rra(ia)
	       eazm(1)=eazm(ia)
	       eev(1)=eev(ia)
	       do k=1,maxi
		vr(1,k)=vr(ia,k)
	       enddo
               ia=1
               timerad1=timerad(ia)
	   endif
	   elv0=elv1
	   elv1=eev(ia)
           azi1=eazm(ia)
           timerad2=timerad(ia)
	end do do_get_vr_loop
	end
