C fragments for reading HRD tape or file
C note change in array dims from 512 to 1024 for rvp8
C added declarations for every damn variable in the
C common blocks, so can use "implicit none" in my
C software thah includes this file.
C

	real bad_flag, bad_w
	integer missing, max_hrd_dim
	parameter(bad_flag=-900.0, missing = -9999)
	parameter( bad_w = -9000.0)
C RVP8 can have more gates per ray thn old rvp5, so i made
C ths array dim bigger, so radar_rvp8_read wont crash. Note ttu uses array sizes greater
C than this, but aoc radars should not... 12 july 2012
	parameter(max_hrd_dim = 2048)
C
C Radar tape/file stuff
	COMMON /TAPEHEADER/ 
     +	nbytesheader,ntape,nversion,ihheader,imheader,
     +  isheader,ine,ndrive,naircraft,flightid,stmname,
     +  nsamplelf,nsampleta,refslopelf,refslopeta,
     +  refnoisethreslf,refnoisethresta,sqilf,sqita,
     +  widththreslf,widththresta,caliblf,calibta,
     +  modedatalf,modedatata,noisetmlf,noisetmta,
     +  rpmlf,rpmta,gtlnlf,ivrangelf,ivrangeta,
     +   gtlnta(3),rdellf,rdelta,rdelcorlf,rdelcorta,
     +   nbinlf,nbinta,nbins,rmaxlf,rmaxta,
     +   radiita(max_hrd_dim),radiilf(max_hrd_dim),
C following 6 variables are new:
     +	 prf_flaglf, prf_flagta, prf_highlf,
     +	 prf_highta, xniqlf, xniqta, 
     +	iheader(1024)
C
	COMMON /RAYHEADER / 
     + nbytesdata,nlfsweep,ntasweep,numrecord,
     + recflag,idradar,nbytesray,icode,idsp,mdata,
     + iyear,month,iday,iraycode,time,ih,im,
     + is,is100,rlat,rlon,ra,gse,gsn,gs,vgs,
     + ucom,vcom,wd,ws,vws,ircu,
     +  elev,azm,pitch,roll,drift,heading,
     +  dbzbuffer(max_hrd_dim),
     +	velbuffer(max_hrd_dim),
     +   widthbuffer(max_hrd_dim)
C

C declare all the other f***ing variables...
	real  
     + refslopelf,refslopeta,
     +  refnoisethreslf,refnoisethresta,sqilf,sqita,
     +  widththreslf,widththresta,caliblf,calibta,
     +  rpmlf,rpmta,gtlnlf,
     +   gtlnta,rdellf,rdelta,rdelcorlf,rdelcorta,
     +   rmaxlf,rmaxta,
     +   radiita,radiilf,
     +	 prf_highlf, prf_highta, xniqlf, xniqta,
     + recflag,
     + time,
     + rlat,rlon,ra,gse,gsn,gs,vgs,
     + ucom,vcom,wd,ws,vws,
     +  elev,azm,pitch,roll,drift,heading,
     +  dbzbuffer,
     +	velbuffer,
     +   widthbuffer

C and now for the integers

	integer 
     +	nbytesheader,ntape,nversion,ihheader,imheader,
     +  isheader,ine,ndrive,naircraft,
     +  nsamplelf,nsampleta,
     +  modedatalf,modedatata,noisetmlf,noisetmta,
     +  ivrangelf,ivrangeta,
     +   nbinlf,nbinta,nbins,
     + nbytesdata,nlfsweep,ntasweep,numrecord,
     + idradar,nbytesray,icode,idsp,mdata,
     + iyear,month,iday,iraycode,ih,im,
     + is,is100,ircu

	integer*2 iheader
	integer prf_flaglf, prf_flagta
      INTEGER time_ta, time_lf
	integer bins_lf, bine_lf, bins_ta, binm_ta, bine_ta
      CHARACTER FLIGHTID*8,STMNAME*16

