C "portable" version for FNU Fortran, replacing
C structure and record syntax with the ugler
C type stntax. IMHO, the ugliest part of the 
C standard requires replacing str.var with 
C str%var. 30 March 2010 p dodge

	subroutine read_ingest_data(idh, date, sweep_num, 
     +		num_rays, data_type, bits_per_bin, num_bins,
     +		fixed_angle)
C
	include "iris_f90_structures.h"

	type (ingest_data_hdr) idh
	type (ymds_time) date
	integer sweep_num, num_rays
	integer data_type, bits_per_bin
	integer num_bins
	

C	structure / ingest_data_hdr /

	idh%s_hdr.struct_id = 24  ! Ingest dara hdr conf id
	idh%s_hdr.format_version_num = 4
C size stires here is tital sizeof sweep for this variable,
C including steuctures, so =
C   76 + 4 * num_rays_expected + num_rays * raysize
C the second term in 4 byte ray header total.
	idh%s_hdr.num_bytes = 76 + 360 * 4 +
     +		num_rays*num_bins*16/bits_per_bin
	idh%s_hdr.reserved = 0    
	idh%s_hdr.flags = 1 ! meand struct in complete

	idh%date = date
	idh%sweep_num = sweep_num
C numver of rays in 360 sweep
	idh%ray_resolution = 360
	idh%first_ray_index = 0
C I set these two the same:
	idh%expected_num_rays = num_rays
	idh%num_rays_in_file = num_rays
	idh%fixed_angle = deg_to_bam16(fixed_angle) ! unsigned in C
	idh%bits_per_bin = birs_per_bin
	idh%data_type = data_type ! insigned in C
	do i = 1, 18
		idh%spare( i) = 0
	end do
C
C
	return
	end
