C fragments for reading HRD tape or file
C note change in array dims from 512 to 1024 for rvp8
	parameter(bad_flag=-900.0, missing = -9999)
	parameter( bad_w = -9000.0)
	parameter(max_hrd_dim = 2048)
C
C Radar tape/file stuff
	COMMON /TAPEHEADER/ 
     +	nbytesheader,ntape,nversion,ihheader,imheader,
     +  isheader,ine,ndrive,naircraft,flightid,stmname,
     +  nsamplelf,nsampleta,refslopelf,refslopeta,
     +  refnoisethreslf,refnoisethresta,sqilf,sqita,
     +  widththreslf,widththresta,caliblf,calibta,
     +  modedatalf,modedatata,noisetmlf,noisetmta,
     +  rpmlf,rpmta,gtlnlf,ivrangelf,ivrangeta,
     +   gtlnta(3),rdellf,rdelta,rdelcorlf,rdelcorta,
     +   nbinlf,nbinta,nbins,rmaxlf,rmaxta,
     +   radiita(max_hrd_dim),radiilf(max_hrd_dim),
C following 6 variables are new:
     +	 prf_flaglf, prf_flagta, prf_highlf,
     +	 prf_highta, xniqlf, xniqta, 
     +	iheader(1024)
C
	COMMON /RAYHEADER / 
     + nbytesdata,nlfsweep,ntasweep,numrecord,
     + irecflag,idradar,nbytesray,icode,idsp,mdata,
     + iyear,month,iday,iraycode,radtime,ih,im,
     + is,is100,radlat,radlon,radalt,gse,gsn,radgs,radvgs,
     + ucom,vcom,radwd,radws,radvws,ircu,
     +  elev,radazm,pitch,roll,drift,heading,
     +  dbzbuffer(max_hrd_dim),
     +	velbuffer(max_hrd_dim),
     +   widthbuffer(max_hrd_dim)
C
	integer*2 iheader
	integer prf_flaglf, prf_flagta
      INTEGER LUT,BIN1,BIN2,NWEDGE,KINDRADAR, time_ta, time_lf
	integer bins_lf, bine_lf, bins_ta, binm_ta, bine_ta
      CHARACTER FLIGHTID*8,STMNAME*16






