C NN=N1
C N=NPOINTS
C NNNN=NPOINTS
C N4=N1
C NZ=NARRAY
C NW=NWORK
C NNNNN=NARRAY
      SUBROUTINE SOLVESPARSE(N1,NPOINTS,IPOS,
     + SX,SY,SZ,VELS,LU,A,RHS,INDEX1,INDEX2,DOTMIN,
     + LUO,OFILNAM,KEYWORDB,FLTNAME,
     +  STMNAME,RADAR,EXPERIMENT,
     +  CREATIME,EXTRA1,KOUNT,NMOSM,
     +  IUNFLD,IATTEN,IFLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     +  XZB,YZB,ZZB,ROTB,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     +  POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7,
     +  IGUESS,X,IUV,NORM,
     +  INDXN,NARRAY,NWORK,IA,JA,IWORK,WORK,
     +  ITMAX,JKI,INDEX4,NXYZ,NTOTAL,ICONVERGENCE)
      INTEGER IA(NPOINTS),JA(NARRAY),IWORK(NARRAY),INDEX4(NXYZ)
      DOUBLE PRECISION A(NARRAY),RHS(NPOINTS),WORK(NWORK),X(NPOINTS)
      REAL VELS(NPOINTS)
      DOUBLE PRECISION NORM(NPOINTS)
      INTEGER INDEX1(NPOINTS),INDEX2(NPOINTS)
      CHARACTER KEYWORDB*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,OFILNAM*80
      COMMON /JPOSI/JPOSITIONU,JPOSITIONV,JPOSITIONW
      INTEGER KOUNT,NMOSM,IUNFLD,IATTEN,IFLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,XZB,YZB,ZZB,ROTB,RA,CO1
      REAL CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2
      REAL EXTRA6,EXTRA7
      DOUBLE PRECISION RPARM(12)
      INTEGER IPARM(12)
      write(6,*)'entered solvesparse_fourier_auto.f'
      FLAG=-1.0E+10 
c      WRITE(6,*)'IPOS = ',IPOS
      NN=N1
      N=NPOINTS
      NNNN=NPOINTS
      N4=N1
      NZ=NARRAY
      NW=NWORK
      NNNNN=NARRAY
      write(6,*)'nw = ',nw
      write(6,*)'index1(1) = ',index1(1)
      OPEN(88,FILE='indexnorm',FORM='UNFORMATTED')
      write(6,*)'n,nn,nnnn,n4 = ',n,nn,nnnn,n4
      WRITE(88)N,NN,NNNN,INDEX2,NORM,INDEX4
      CLOSE(88)
      DO I=1,IPOS 
       IF(IGUESS.EQ.0)THEN
       X(I)=0. 
       ELSE
        X(I)=VELS(INDEX1(I))/NORM(I)
        IF(X(I).LT.-1.0E+8)THEN
         WRITE(6,*)'I,INDEX1(I),X(I) = ',I,INDEX1(I),X(I)
        ENDIF
       ENDIF
      ENDDO 
      CALL DFAULT(IPARM,RPARM)
      IPARM(1)=10000
      IPARM(2)=2
      IPARM(3)=0
      IPARM(4)=6
      IPARM(5)=0
      IPARM(6)=0
      IPARM(7)=1
      IPARM(8)=0
      IPARM(9)=-1
      IPARM(10)=0
      IPARM(11)=0
      IPARM(12)=0
      IF(ICONVERGENCE.EQ.2)THEN
         RPARM(1)=1.0E-06
      ELSE
         RPARM(1)=1.0E-04
      ENDIF
      RPARM(2)=0.
      RPARM(3)=0.
      RPARM(4)=.75
      RPARM(5)=1.3
      RPARM(6)=0.
      RPARM(7)=.25
      RPARM(8)=7.11E-13
      RPARM(9)=0.
      RPARM(10)=0.
      RPARM(11)=0.
      RPARM(12)=0.
c      RPARM(5)=1.3
c      RPARM(1)=1.0E-08
c      OPEN(111,FILE='parameters')
c      READ(111,*)IPARM
c      READ(111,*)RPARM
c      CLOSE(111)
      WRITE(6,*)'IPOS,NW,NNNN,NNNNN = ',IPOS,NW,NNNN,NNNNN
      WRITE(6,*)'IPARM = ',IPARM
      WRITE(6,*)'RPARM = ',RPARM
      write(6,*)'itmax = ',itmax
      IPARM(1)=ITMAX
c      do i=1,ipos
c       WRITE(6,*)'i,rhs(i) = ',i,rhs(i)
c      enddo
      CALL SSORCG(IPOS,IA,JA,A,RHS,X,IWORK,NW,WORK,IPARM,RPARM,IER)
      WRITE(6,*)'IPARM = ',IPARM
      WRITE(6,*)'RPARM = ',RPARM
      WRITE(6,*)'NTOTAL = ',NTOTAL
10    DO I=1,NTOTAL
c       CLOSE(103)
c       write(6,*)'i,index2(i),x(index2(i)),norm(index2(i)) = ',
c     1            i,index2(i),x(index2(i)),norm(index2(i))
       IF(INDEX2(I).GT.0)THEN 
        VELS(I)=X(INDEX2(I))*NORM(INDEX2(I))
       ELSE 
        VELS(I)=FLAG 
       ENDIF
      ENDDO 
      WRITE(6,*)'RETURNING FROM SOLVESPARSE'
      RETURN
      END 

